// A fan game by poret. This game is not affiliated with SNK. This is a fan game which is not being sold or distributed for profit.


#include "Character/KOFBaseCharacter.h"

#include "PaperFlipbookComponent.h"
#include "Components/InputComponent.h"
#include "KOFForever/KOFTypes.h"

// Sets default values
AKOFBaseCharacter::AKOFBaseCharacter()
{
 	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;
	
	Sprite = CreateOptionalDefaultSubobject<UPaperFlipbookComponent>(TEXT("Sprite"));
	if (Sprite)
	{
		Sprite->AlwaysLoadOnClient = true;
		Sprite->AlwaysLoadOnServer = true;
		Sprite->bOwnerNoSee = false;
		Sprite->bAffectDynamicIndirectLighting = true;
		Sprite->SetupAttachment(RootComponent);
		Sprite->SetRelativeLocation(FVector(0.0f, 0.0f, 96.0f));
	}
	
	// Try to create the sprite component
	Shadow = CreateOptionalDefaultSubobject<UPaperFlipbookComponent>(TEXT("Shadow"));
	if (Shadow)
	{
		Shadow->AlwaysLoadOnClient = true;
		Shadow->AlwaysLoadOnServer = true;
		Shadow->bOwnerNoSee = false;
		Shadow->bAffectDynamicIndirectLighting = true;
		Shadow->SetupAttachment(Sprite);
		//Shadow->SetRelativeLocation(FVector(0.0f, 0.0f, -96.0f));
		Shadow->SetRelativeScale3D(FVector(1.0f, 1.0f, -0.3f));
		Shadow->SetSpriteColor(FLinearColor::Black);
	}
	
	MaxWalkSpeed = 400;
}

void AKOFBaseCharacter::SetPosition(FFixedVector Param)
{
	Position = Param;
}

void AKOFBaseCharacter::SetupPlayerInputComponent(UInputComponent* PlayerInputComponent)
{
	Super::SetupPlayerInputComponent(PlayerInputComponent);

	PlayerInputComponent->BindAxis("MoveRight", this, &AKOFBaseCharacter::MoveRight);
	
	RegisterInput("Up", EVirtualGamePadButton::VGP_Up);
	RegisterInput("Down", EVirtualGamePadButton::VGP_Down);
	RegisterInput("Left", EVirtualGamePadButton::VGP_Left);
	RegisterInput("Right", EVirtualGamePadButton::VGP_Right);
}

void AKOFBaseCharacter::ProcessInputs(EVirtualGamePadButton Button)
{
	/*
	switch(Button)
	{
		case EVirtualGamePadButton::VGP_Left:
			Position = FFixedVector(0, -250, 0);
			break;
		case EVirtualGamePadButton::VGP_Right:
			Position = FFixedVector(0, 250, 0);
			break;
	}
	*/
}

void AKOFBaseCharacter::RegisterInput(FName ActionName, EVirtualGamePadButton Button)
{
	check(InputComponent != nullptr);
	
	FInputActionHandlerSignature ActionHandler;
	ActionHandler.BindUObject(this, &AKOFBaseCharacter::ProcessInputs, Button);

	FInputActionBinding ActionBinding(ActionName, IE_Pressed);
	ActionBinding.ActionDelegate = ActionHandler;
	InputComponent->AddActionBinding(ActionBinding);
}

void AKOFBaseCharacter::MoveRight(float Axis)
{
	Direction = Axis;
}

void AKOFBaseCharacter::UpdateMovement(FFixed DeltaTime)
{
	FFixedVector Velocity = FFixedVector(0, Direction * MaxWalkSpeed, 0); 
	Position +=  Velocity * DeltaTime;
}

// Called when the game starts or when spawned
void AKOFBaseCharacter::BeginPlay()
{
	Super::BeginPlay();
	
	SetActorLocation(FVector(Position));
	SetActorRotation(FRotator(0.0f, 90.0f, 0.0f));
}

// Called every frame
void AKOFBaseCharacter::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);

	UpdateMovement(FFixed(DeltaTime));

	// might need some helpers to convert a FFixedVector to a FVector
	SetActorRelativeLocation(FVector(Position));
}

