// A fan game by poret. This game is not affiliated with SNK. This is a fan game which is not being sold or distributed for profit.

#pragma once

#include "CoreMinimal.h"
#include "../../../../Plugins/FixedPointMath/Source/FixedPointMath/Public/FixedVector.h"
#include "GameFramework/Actor.h"
#include "KOFBaseCharacter.generated.h"

enum class EVirtualGamePadButton : uint8;
UCLASS()
class KOFFOREVER_API AKOFBaseCharacter : public APawn
{
	GENERATED_BODY()
	
public:	
	// Sets default values for this actor's properties
	AKOFBaseCharacter();

	void SetPosition(FFixedVector Param);
	
protected:
	/** The main flipbook representing the character */
	UPROPERTY(Category = Character, VisibleAnywhere, BlueprintReadOnly, meta = (AllowPrivateAccess = "true"))
	class UPaperFlipbookComponent* Sprite;
	
	/**
	 *	Secondary sprite that is mirrored across the ground axis and set to black to give the effect of a
	 *  character's shadow
	 */
	UPROPERTY(Category = Character, VisibleAnywhere, BlueprintReadOnly, meta = (AllowPrivateAccess = "true"))
	class UPaperFlipbookComponent* Shadow;

	// movement
	// need a way to expose this to the editor as a float slider/entry
	UPROPERTY(EditDefaultsOnly, BlueprintReadOnly, Category="Settings|Movement")
	FFixed MaxWalkSpeed;

	int Direction;
	
	FFixedVector Position;
	
	/**
	 * 
	 * @param  PlayerInputComponent
	 */
	virtual void SetupPlayerInputComponent(UInputComponent* PlayerInputComponent) override;

	// for now just takes a button but eventually will take an entire gamepad state
	void ProcessInputs(EVirtualGamePadButton Button);

	void RegisterInput(FName ActionName, EVirtualGamePadButton Button);

	void MoveRight(float Axis);
	
	void UpdateMovement(FFixed DeltaTime);
	
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

};
